#!/usr/local/bin/perl
printf "make all\n";
system("make all");
system("cd Barnes-Hut; make all; cd ../");
printf "make all done\n";


sub runprogram{
    local($command, $args) = @_;
    print "\nrunning ", $command, "\n";
    $syscom = $command." ".$args." >> timings 2> tmptmp";
    system($syscom);
    $value = ($? >> 8);   
    if ($value == 0){     
	print $command;
	print (" -------- OK\n");
    }
    else{
	print ("*** Error running ");
	print $command;
	print (" ***\n exit value = ");
	print $value;
	print ("\n");
	system("cat rtest_tmp");
	exit 0;
    }
}

sub runall{
    local($procs) = @_;
    &runprogram("blockedmul",      "-stats 0 -nproc $procs");
    &runprogram("bucket",          "-stats 0 -nproc $procs");
    &runprogram("cholesky",        "-stats 0 -nproc $procs");
    &runprogram("cilksort",        "-stats 0 -nproc $procs");
    &runprogram("ck",              "-stats 0 -nproc $procs");
    &runprogram("fft",             "-stats 0 -nproc $procs");
    &runprogram("fib",             "-stats 0 -nproc $procs");
    &runprogram("game",            "-stats 0 -nproc $procs"); 
    &runprogram("heat",            "-stats 0 -nproc $procs");
    &runprogram("knapsack",        "-stats 0 -nproc $procs");
    &runprogram("knary",           "-stats 0 -nproc $procs");
    &runprogram("lu",              "-stats 0 -nproc $procs");
    &runprogram("magic",           "-stats 0 -nproc $procs");
    &runprogram("notempmul",       "-stats 0 -nproc $procs");
    &runprogram("queens",          "-stats 0 -nproc $procs");
    &runprogram("spacemul",        "-stats 0 -nproc $procs");
    &runprogram("strassen",        "-stats 0 -nproc $procs");
    &runprogram("rectmul",         "-stats 0 -nproc $procs");

    &runprogram("Barnes-Hut/code", "-stats 0 -nproc $procs < Barnes-Hut/sample-input");

}

system("rm timings");
&runall(8);
system("rm tmptmp");
